#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Reciprocal Link Checker (Unix/Linux Operating Systems Only)
# DIZ: Enables you to check if your reciprocal links still exists and if not you can send email to link owners asking them to place your link back.
# GRAPHIC: ic_settings6.gif
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;
use LWP::UserAgent;


&get_setup;
$q = CGI->new;


$pages_prev = "3";
$pages_next = "3";


### FIELD extf3 = reciprocal link

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "email_all") { &email_all; }
if ($q->param('fct') eq "domailing_all") { &domailing_all; }
if ($q->param('fct') eq "mailing_process") { &mailing_process; }
if ($q->param('fct') eq "clear_report") { &clear_report; }
if ($q->param('fct') eq "clear_report2") { &clear_report2; }
if ($q->param('fct') eq "do_options") { &do_options; }
if ($q->param('fct') eq "setup") { &setup; }



##################################################################################

sub setup
{


$hbox = acs::get_heading_box("$web_url/ic_help.gif", "How to enabled Reciprocal Link Checking", qq[
<a href="$admin_url/p_recip.cgi">Go back</a>
]);



print qq[<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox
<p><span style="font-family: Arial; font-size: 13; line-height: 20px">The reciprocal link
checker will check if a submitter placed a link to your web site when he/she does a
submission. You can have this enabled when visitors submit standard and/or premium links.
If you are new to PowerSeek then it would be best to first customize the look and feel of
your Search Engine and Directory before you enable the reciprocal link checker. This will
ensure that you are familiar with the terms and references in the instructions below.</span></p>

<blockquote>
  <p><span style="font-family: Arial; font-size: 13; line-height: 20px"><strong>Follow the
  following steps to enable reciprocal link checking:</strong></span></p>
  <p><font color="#0000A0"><span
  style="font-family: Arial; font-size: 13; line-height: 20px"><strong>Step 1 - Enabled the
  Reciprocal Link Checker Settings</strong></span></font></p>
  <blockquote>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px">Go to the Powerseek
    Control Panel &gt;&gt; Settings &gt;&gt; Global Engine Settings &gt;&gt; Submission
    Settings</span></p>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px"><strong>Look for 3
    settings that reads:</strong></span></p>
    <blockquote>
      <p><span style="font-family: Arial; font-size: 13; line-height: 20px"><strong>Enable the
      reciprocal link checker for standard URL's?<br>
      </strong>If you would like to check for a reciprocal link when a visitors submits a
      standard link then set this to 'Yes'.</span></p>
      <p><span style="font-family: Arial; font-size: 13; line-height: 20px"><strong>Enable the
      reciprocal link checker for premium URL's?<br>
      </strong>If you would like to check for a reciprocal link when a visitors submits a
      premium link then set this to 'Yes'.</span></p>
    </blockquote>
    <blockquote>
      <p><span style="font-family: Arial; font-size: 13; line-height: 20px"><strong>If you
      answered 'Yes' above then specify the URL that should be looked for at the submitters web
      site:<br>
      </strong>On your submission forms you will need to provide the submitter with HTML code
      that he/she can place on his/her web site. This HTML code will need to include a URL to
      your web site. Specify that URL in this setting. The reciprocal link checker will connect
      to the submitters web site and download the page and look for this URL inside the page.
      The page it downloads will be the the reciprocal link the submitter provides on the Add
      URL form.</span></p>
    </blockquote>
  </blockquote>
  <p><font color="#0000A0"><span
  style="font-family: Arial; font-size: 13; line-height: 20px"><strong>Step 2 - Edit Add URL
  forms</strong></span></font></p>
  <blockquote>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px">Go to the Powerseek
    Control Panel &gt;&gt; Template Manager &gt;&gt; Edit your Add URL forms. These are the
    forms that is displayed to visitors when they need to enter their link details to do a
    submission.</span></p>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px">If you enabled
    reciprocal link checking for standard links then edit your standard Add URL form. Add the
    following to the form:</span></p>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px"><strong>Reciprocal
    Link: &lt;input type=&quot;text&quot; name=&quot;reciprocal&quot; size=&quot;45&quot;&gt;
    (This it the URL on your web site where you have placed a link to us)</strong></span></p>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px">If you enabled
    reciprocal link checking when visitors submit a premium link then edit the Premium Add URL
    form as well and add the same HTML code. </span></p>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px">Now you will only be
    able to accept submissions from visitors who have placed a link to your web site.</span></p>
  </blockquote>
</blockquote>

<blockquote>
  <p><font color="#0000A0"><span
  style="font-family: Arial; font-size: 13; line-height: 20px"><strong>Step 3 - Edit Modify
  Forms</strong></span></font></p>
  <blockquote>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px">Go to the Powerseek
    Control Panel &gt;&gt; Template Manager &gt;&gt; Edit your Modify URL forms. These are the
    forms that is displayed to visitors when they want to modify an existing link listing.</span></p>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px">If you enabled
    reciprocal link checking for standard links then edit your standard 'Modify / Edit Link'
    form. Add the following to the form:</span></p>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px"><strong>Reciprocal
    Link: &lt;input type=&quot;text&quot; name=&quot;reciprocal&quot; size=&quot;45&quot;
    value=&quot;!!modify_recip!!&quot;&gt; (This it the URL on your web site where you have
    placed a link to us)</strong></span></p>
    <p><span style="font-family: Arial; font-size: 13; line-height: 20px">If you enabled
    reciprocal link checking when visitors modify a premium link then edit the Premium
    &nbsp; 'Modify / Edit Link' form as well and add the same HTML code. </span></p>
  </blockquote>
</blockquote>
</body>
</html>
];


}


sub do_options
{

$nr_links = $q->param('nr_links');
$cnt =0;

	for ($ms = 0; $ms <= $nr_links; $ms++) 
		{
		$varname = "C" . $ms;

		if ($q->param($varname) ne "")
			{
			$link_selected = "true";
			
			($rlnkid, $tmpcid) = split (/-/, $q->param($varname));
			$ar_lnkid[$cnt] = $rlnkid;
			
			$ar_lnkid_cid[$cnt] = $q->param($varname);
			$cnt++;
			}
		
		
		}

if ($link_selected ne "true") { acs::problem_popup("You have to select something to perform an operation on."); }


$opaction= $q->param('opaction');


if ($opaction eq "remove")
	{
	foreach $item (@ar_lnkid)
		{
		$where_sql = $where_sql . " (lnkid = '$item') OR";
		}
		
		$where_sql = substr($where_sql, 0, length($where_sql) -2);
	
	
	
	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	$sql = "DELETE FROM reciphist WHERE $where_sql";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: $sql";}
	
	$sth->finish;
	$dbh->disconnect;

$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Report Entry Removed", qq[
<a href="javascript:onClick=window.close()">Click Here to close this window.</a>
]);
	
print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);"> 
$hbox
</body>
</html>
];
	
	}
if ($opaction eq "sendmail")
	{
	
	foreach $item (@ar_lnkid)
			{
			$sel_items = $sel_items  . $item . ",";
			}
	chop($sel_items);
	
	&send_email_all($sel_items);
	}
if ($opaction eq "edit") ########################################################################
	{

	$itcnt = 0;
	foreach $item (@ar_lnkid_cid)
		{
		$single_item = "&C" . $itcnt . "=" . $item;
		
		$pass_item = $pass_item . $single_item;
		
		$itcnt++;
		}
	
	
	$forwardlnk = "$admin_url/admin56.cgi?dropdown=Edit&itemnrs=$nr_links" . $pass_item;


print qq[<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$forwardlnk">
</head>
<body>
</body>
</html>
];

exit;	

	}
if ($opaction eq "delete") ########################################################################
	{

	foreach $item (@ar_lnkid)
		{
		$pass_item = $pass_item . $item . "-";
		
		$del_sql = $del_sql . " (lnkid = '$item') OR";
		}
	
	chop($pass_item);
	$del_sql = substr($del_sql, 0, length($del_sql) - 2);
	
	$forwardlnk = "$admin_url/admin56.cgi?fct=delete_listings&links=" . $pass_item;


	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
	
		$sql = "DELETE FROM reciphist WHERE $del_sql";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}

	$sth->finish;
	$dbh->disconnect;



print qq[<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$forwardlnk">
</head>
<body>
</body>
</html>
];

exit;	

	}
if ($opaction eq "move") ########################################################################
	{

	$itcnt = 0;
	foreach $item (@ar_lnkid_cid)
		{
		$single_item = "&C" . $itcnt . "=" . $item;
		
		$pass_item = $pass_item . $single_item;
		
		$itcnt++;
		}
	
	
	$forwardlnk = "$admin_url/admin56.cgi?dropdown=Move&itemnrs=$nr_links" . $pass_item;


print qq[<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$forwardlnk">
</head>
<body>
</body>
</html>
];

exit;	

	}



}




sub mailing_process
{

$selected_email = $q->param('selected_email');

$total = $q->param('total');
$emailnr = $q->param('emailnr');
$pos = $q->param('pos'); if ($pos eq "") { $pos = 0; }


if ($selected_email ne "")
	{
	$emailmsg = acs::get_file_contents("$data_dir/recip3.dat");
	}
	else
	{
	$emailmsg = acs::get_file_contents("$data_dir/recip2.dat");
	}


@emlines = split(/\n/, $emailmsg);

$from_email = $emlines[0];
$from_name = $emlines[1];
$subject = $emlines[2];

$rc = 0;
foreach $item (@emlines)
	{
	if ($rc > 2)
		{
		$email_message = $email_message . $item . "\n";
		}
		$rc++;
	}
 


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }



if ($selected_email ne "")
	{
	@se_items = split(/,/,$selected_email);
	
		foreach $seml_item (@se_items)
			{
			$sel_email_sql = $sel_email_sql . " (lnkid = '$seml_item') OR";
			}
	
	$sel_email_sql = substr($sel_email_sql, 0, length($sel_email_sql) - 2);
	}
	else
	{
	$sel_email_sql = "response LIKE '%200%' OR response LIKE '%404%'";
	
	}
	

	$sql = "SELECT * FROM reciphist WHERE $sel_email_sql LIMIT $pos, $emailnr";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: $sql";}
	$rows = $sth->rows();

		while ( @row = $sth->fetchrow() )
			{
			$email_message_tmp = $email_message;
			
			$email_message_tmp =~ s/!!recip!!/$row[6]/gi;
			$email_message_tmp =~ s/!!login_link!!/$script_url\/rgs_login\.cgi/gi;
			
			$email_message_tmp =~ s/!!title!!/$row[7]/gi;
			$email_message_tmp =~ s/!!diz!!/$row[8]/gi;
			$email_message_tmp =~ s/!!url!!/$row[9]/gi;
			
			
			$to_send_to_email = $row[10];
			
			### SEND EMAIL TO LINK OWNER
			acs::send_email ($from_name, $from_email, $to_send_to_email, $subject, $email_message_tmp); 
			
			}

$sth->finish;
$dbh->disconnect;


if ($pos > $total)
	{
	
if ($selected_email ne "") { $continue = qq[You may <a href="javascript:onClick=window.close()">close</a> this window.]; }
else
{ $continue = qq[ <a href="$admin_url/recip2.cgi">Click here to continue</a>]; }


$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Email Sent", qq[
$continue
]);
 

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];
exit;
	}


$pos = $pos + $emailnr;


$cperc = ($pos / $total) * 100;
$cperc = sprintf("%5.2f",$cperc);  

if ($cperc > 100) { $cperc = 100; }

$cperc = $cperc . "%";


$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Sending Email...", qq[
<table border="0" cellspacing="1" width="100%" cellpadding="0" bgcolor="#E5E5E5">
  <tr>
    <td width="20%" bgcolor="#FFFFFF" align="center"><img src="$web_url/working.gif"
    width="270" height="36"></td>
    <td width="20%" bgcolor="#FFFFFF" align="center"><font face="Verdana" size="1"><strong>$cperc
    Complete</strong></font></td>
    <td width="60%" bgcolor="#FFFFFF"><table border="0" cellpadding="0" cellspacing="0"
    width="$cperc">
      <tr>
        <td width="100%" background="$web_url/bar.gif" height="30"><font color="#FCDB56">_</font></td>
      </tr>
    </table>
    </td>
  </tr>
</table>
]);

print qq[<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH"
CONTENT="1;URL=$admin_url/recip2.cgi?fct=mailing_process&amp;total=$total&amp;emailnr=$emailnr&amp;pos=$pos&selected_email=$selected_email">
</head>
<body>
$hbox
</body>
</html>

];

}




sub domailing_all
{

$emailnr = $q->param('emailnr');

$selected_email = $q->param('selected_email');

if ($q->param('from_email') eq "") { acs::problem_popup("You have to provide an email address from which email is sent."); }
if ($q->param('from_name') eq "") { acs::problem_popup("You have to provide a name from which email will be sent."); }
if ($q->param('subject') eq "") { acs::problem_popup("You have to provide a subject for the email message"); }
if ($q->param('message') eq "") { acs::problem_popup("You have to provide a message for the email message"); }


#$from_email = $emlines[0];
#$from_name = $emlines[1];
#$subject = $emlines[2]; 

if ($selected_email ne "")
	{
open (EMD, "> $data_dir/recip3.dat");
	print EMD $q->param('from_email') . "\n";
	print EMD $q->param('from_name') . "\n";
	print EMD $q->param('subject') . "\n";
	print EMD $q->param('message');
close (EMD);
	}
	else
	{
open (EMD, "> $data_dir/recip2.dat");
	print EMD $q->param('from_email') . "\n";
	print EMD $q->param('from_name') . "\n";
	print EMD $q->param('subject') . "\n";
	print EMD $q->param('message');
close (EMD);
	}



if ($q->param('testbut') eq "   Send Test Email    ")
	{
	if ($q->param('test_email') eq ""){ acs::problem_popup("You have to provide an email address to which the test message will be sent."); }
	
	$test_mess = $q->param('message');
	
	$reciplnk = "http://www.somewhere.com/some_recip_link.html";
	$test_mess =~ s/!!recip!!/$reciplnk/gi;
	
	$test_mess =~ s/!!login_link!!/$script_url\/rgs_login\.cgi/gi;
	
	$test_mess =~ s/!!title!!/Some Link Title/gi;
	$test_mess =~ s/!!diz!!/Some Description/gi;
	
	$testurl = "http://www.somewhere.com";
	$test_mess =~ s/!!url!!/$testurl/gi;
	
	acs::send_email ($q->param('from_name'), $q->param('from_email'), $q->param('test_email'), $q->param('subject'), $test_mess); 



$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Test Email Sent", qq[
<a href="$admin_url/recip2.cgi?fct=email_all&amp;selected_email=$selected_email&amp;B1=Send Email to All">
Click here to continue</a>
]);

print qq[<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];	
	
	exit;
	}



	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
 	$dbh = DBI->connect($dsn, $db_username, $db_password);
 	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


if ($selected_email ne "")
	{
	@se_items = split(/,/,$selected_email);
	
		foreach $seml_item (@se_items)
			{
			$sel_email_sql = $sel_email_sql . " (lnkid = '$seml_item') OR";
			}
	
	$sel_email_sql = substr($sel_email_sql, 0, length($sel_email_sql) - 2);
	
	}
	else
	{
	$sel_email_sql = "response LIKE '%200%' OR response LIKE '%404%'";
	}

	$sql = "SELECT * FROM reciphist WHERE $sel_email_sql";
	
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: $sql";}
	$rows = $sth->rows();

	$sth->finish;
	$dbh->disconnect;


print qq[<html>
 <head>
 <title>PowerSeek</title>
 <meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/recip2.cgi?fct=mailing_process&total=$rows&emailnr=$emailnr&selected_email=$selected_email">
 </head>
 <body>
 $contents2
 </body>
 </html> 
];


}





sub email_all
{

if ($q->param('B1') ne "") 
	{
	&send_email_all; 
	}
elsif ($q->param('B2') ne "") 
	{
	&clear_report; 
	}
elsif ($q->param('B3') ne "") 
	{
	&set_per_page; 
	}


}


sub set_per_page
{

open (DTAP, "> $data_dir/recip.dat");
print DTAP $q->param('perpage');
close (DTAP);


$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Settings Updated", qq[
<a href="$admin_url/recip2.cgi">Click Here to Continue.</a>
]); 


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox
</body>
</html>
];


}




sub clear_report2
{

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
 	$dbh = DBI->connect($dsn, $db_username, $db_password);
 	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	$sql = "DELETE FROM reciphist";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: $sql";}

	$sth->finish;
	$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Reciprocal Link Report Cleared", qq[
<a href="$admin_url/p_recip.cgi">Click Here To Continue</a>
]);

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox
</body>
</html>
];



}




sub clear_report
{

$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Clear The Reciprocal Link Report", qq[
<strong>Are you sure? <a href="$admin_url/recip2.cgi?fct=clear_report2">Yes</a> | <a href="$admin_url/recip2.cgi">No</a></strong>
]);

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];



}





sub send_email_all
{

my ($selected_email) = @_;

if ($q->param('selected_email') ne "")
	{
	$selected_email = $q->param('selected_email');
	}


if ($selected_email eq "")
{
$emailmsg = acs::get_file_contents("$data_dir/recip2.dat");
}
else
{
$emailmsg = acs::get_file_contents("$data_dir/recip3.dat");
}

@emlines = split(/\n/, $emailmsg);

$from_email = $emlines[0];
$from_name = $emlines[1];
$subject = $emlines[2];

$rc = 0;
foreach $item (@emlines)
	{
	if ($rc > 2)
		{
		$message = $message . $item . "\n";
		}
		$rc++;
	}
	
	



if ($selected_email eq "")
{


	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
 	$dbh = DBI->connect($dsn, $db_username, $db_password);
 	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	$sql = "SELECT * FROM reciphist WHERE response LIKE '%200%' OR response LIKE '%404%'";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: $sql";}
	$rows = $sth->rows();

	$sth->finish;
	$dbh->disconnect;



if ($subject eq "")
	{
	$subject = qq[Our reciprocal link could not be found.];
	}

if ($message eq "")
	{
	
	$gsettings = new_gsettings acs;  
	if ($gsettings->{addurl_reg_system} eq "Yes") 
		{
		$loginlink = qq[To update your listing to specify the new location of where you linked to us you may login here: \n!!login_link!!];
		}
	
$message = qq[Your link is listed with us but we could not find our reciprocal link on your web site.
	
You provided the following link where you have placed a reciprocal link to our web site:
!!recip!!

We kindly ask that you update the page by placing our link on it. 

If you placed the link in another location then please modify your link listed with us to update the location where you have placed our link.

$loginlink

Failure to link to us can result in your link being removed from our Index.

The link you have listed with us is:
!!title!!
!!diz!!
!!url!!


Thanks
Some Company
];
	
	}


$email_header = acs::get_heading_box("$web_url/ic_settings6.gif", "Send Email", qq[
This option will send email to all link owners where your reciprocal link could not be found.<BR><BR>
Note that email will only be sent to link owners where the reciprocal link could not be found or where the page did not exist anymore where your link should have been. There have been $rows such links where your reciprocal link could not be found. Other errors when checking for reciprocal links are ignored as the link may actually be present due to a sluggish connection when the 'Reciprocal Link Checker' checked for the link or another problem where the reciprocal might exist. In other words email will only be sent to link owners where there is a 100% surety that the link on their side is not present anymore.
<BR><BR>
<a href="$admin_url/recip2.cgi"><b>Go Back</b></a>
]);

}
else
{

$email_header = acs::get_heading_box("$web_url/ic_settings6.gif", "Send Email To Selected Links", qq[
This option will send email to the link owners of the links selected in the previous screen.
]);

}



print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$email_header



<form method="POST" action="$admin_url/recip2.cgi">
  <input type="hidden" name="fct" value="domailing_all"><input type="hidden"
  name="selected_email" value="$selected_email"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td width="1225" height="30" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFE135" class="normaltext"><strong>Email
      Message: </strong></td>
    </tr>
    <tr>
      <td width="494" valign="top" bgcolor="#FFFFFF" class="normaltext">From Email Address: </td>
      <td width="717" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="from_email" size="60"
      value="$from_email"> </td>
    </tr>
    <tr>
      <td width="494" valign="top" bgcolor="#FFFFFF" class="normaltext">From Name: </td>
      <td width="717" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="from_name" size="60"
      value="$from_name"> </td>
    </tr>
    <tr>
      <td width="494" valign="top" bgcolor="#FFFFFF" class="normaltext">Subject: </td>
      <td width="717" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="subject" size="60"
      value="$subject"> </td>
    </tr>
    <tr>
      <td width="494" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="717" bgcolor="#FFFFFF" class="normaltext">Message: 
      <p><textarea rows="18" name="message" cols="63">$message</textarea> </td>
    </tr>
    <tr>
      <td width="494" bgcolor="#FFFFFF" class="normaltext">Number of emails to send at a time: </td>
      <td width="717" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="emailnr" size="11" value="10"> <br>
      Only a certain amount of email messages will be sent at a time not to overload your mail
      server. </td>
    </tr>
    <tr>
      <td width="494" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="717" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="   Send   " name="sendbut"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td width="766" height="30" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFE135" class="normaltext"><strong>Send
      a Test Email </strong></td>
    </tr>
    <tr>
      <td width="766" colspan="2" bgcolor="#FFFFFF" class="normaltext">You can send the email message above to the
      email address below. This enables you to see how the message you are going to send looks
      like before mailing link owners. </td>
    </tr>
    <tr>
      <td width="144" valign="top" bgcolor="#FFFFFF" class="normaltext">Send it to email address: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="test_email" size="60"> </td>
    </tr>
    <tr>
      <td width="144" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="   Send Test Email    "
      name="testbut"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>


<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#C0C0C0">
  <tr>
    <td width="966" height="30" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFE135" class="normaltext"><strong>Variables
    that can be used inside this email: </strong></td>
  </tr>
  <tr>
    <td width="966" colspan="2" bgcolor="#FFFFFF" class="normaltext">You may use the variables (words) as listed
    below inside the email message. </td>
  </tr>
  <tr>
    <td width="170" bgcolor="#FFFFFF" class="normaltext">!!recip!! </td>
    <td width="782" bgcolor="#FFFFFF" class="normaltext">The hyperlink indicating where you have been linked
    from. </td>
  </tr>
  <tr>
    <td width="170" bgcolor="#FFFFFF" class="normaltext">!!login_link!! </td>
    <td width="782" bgcolor="#FFFFFF" class="normaltext">Replaced by a URL to where a user can login to update
    his/her link. (To update the reciprocal link location) </td>
  </tr>
  <tr>
    <td width="170" bgcolor="#FFFFFF" class="normaltext">!!title!! </td>
    <td width="782" bgcolor="#FFFFFF" class="normaltext">Replaced by the Title of the the user's link. </td>
  </tr>
  <tr>
    <td width="170" bgcolor="#FFFFFF" class="normaltext">!!diz!! </td>
    <td width="782" bgcolor="#FFFFFF" class="normaltext">Replaced by the Description of the the user's link. </td>
  </tr>
  <tr>
    <td width="170" bgcolor="#FFFFFF" class="normaltext">!!url!! </td>
    <td width="782" bgcolor="#FFFFFF" class="normaltext">Replaced by the ULR of the the user's link. </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>
</form>

</body>
</html>
];

}







sub start
{

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
 	$dbh = DBI->connect($dsn, $db_username, $db_password);
 	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


if ($q->param('total') eq "")
	{
	$sql = "SELECT * FROM reciphist ORDER BY response";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}
	$rows = $sth->rows();
	}
	else
	{
	$rows = $q->param('total');
	}


### SET UP PAGES

$perpage = acs::get_file_contents("$data_dir/recip.dat"); 
if ($perpage eq "") { $perpage = "20"; }

$icnt = $rows;
$nr_searchres = $perpage;


$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$main_nd = $nd;
$main_st = $st;

$ippc = 1;



	$sql = "SELECT * FROM reciphist ORDER BY response LIMIT $st, $perpage";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n<br> From: SELECT * FROM dirs WHERE ((crosslinkid IS NULL) OR (crosslinkid < 1)) AND ((catlock IS NULL) OR (catlock = 'N'))";}


$cbcnt = 0;

		while ( @row = $sth->fetchrow() )
			{
			
			#print "$row[3]<BR><BR>";
			
			@check_items = split (/:-:-:/, $row[3]);
			
			
			$date_displays = ""; $response_displays = "";
			$itcount = 1;
			
			$nr_items = @check_items;
			
			foreach $ch_item (@check_items)
					{
					if ($ch_item ne "")
						{
						($ch_date, $ch_response) = split (/:o:/, $ch_item);
						$ch_date = int($ch_date);
						$ch_date = acs::decode_date($ch_date);
						
						
						if ($itcount == $nr_items)
							{
							$date_displays = $date_displays . $ch_date . "<BR>";
							}
							else
							{
							$date_displays = $date_displays . "<font color=\"#FF0000\">" . $ch_date . "</font><BR>";
							}
							
							$response_displays = $response_displays . $ch_response . "<BR>";
							
						$itcount++;
						}
					}
			
			$cbname = "C" . $cbcnt;
			
			$sel_options = $sel_options . "'C" . $cbcnt . "',";
			
			$rlinks = $rlinks . qq[
			<tr>
			 <td width="1%" bgcolor="#FFFFFF" align="center"> 
			 <input type="checkbox" name="$cbname" value="$row[1]-$row[2]"> 
			 </td>
			 <td width="50%" bgcolor="#FFFFFF"><span style="font-family: Verdana; font-size: 10; line-height: 20px">
			 <a href="$row[9]" target="_blank"><b>$row[7]</b></a><BR>
			 <b>Recip:</b> <a href="$row[6]" target="_blank">$row[6]</a></font></td>
			 <td width="15%" bgcolor="#FFFFFF" align="center"><font face="Verdana" size="1"><b>$date_displays</b></font></td>
			 <td width="34%" bgcolor="#FFFFFF" align="center"><font face="Verdana" size="1">$response_displays</font></td>
    		</tr>
    		];
			
			$cbcnt++;
			}

	$sth->finish;
	$dbh->disconnect;

chop($sel_options);

#### PAGES 

	for ($ms = 0; $ms < $pages; $ms++) 
		{
		$pg = $ms + 1;
		if ($nd == ($pg * $nr_searchres)){ $cnposition = $pg; }
		}
	if ($cnposition < $pages_next) { $pages_next = $pages_next + $pages_next - ($cnposition - 1); }

	$hiddenstr = "";
	$pgstring = "";
	
	if ($main_nd eq "") {$main_nd = $nr_searchres;}
	
	for ($ms = 0; $ms < $pages; $ms++)
		{
		$pg = $ms + 1;
		
			if ($main_nd == ($pg * $nr_searchres))
				{
				$pgstring = $pgstring . " [$pg] ";
				$currentpage = $pg;
				}
			  	elsif (($pg >= ($cnposition - $pages_prev)) and ($pg <= ($cnposition + $pages_next)))
				{
				$st = ($pg * $nr_searchres) - $nr_searchres;
				$nd = ($pg * $nr_searchres);
				$pgstring = $pgstring . "<a href=\"$admin_url/recip2.cgi?st=$st&nd=$nd&total=$rows\">$pg</a> ";
			   }
      } 

			####  PAGES NAVIGATION
			if (($cnposition - $pages_prev) > 1)
				{
				$prev_ppos = $cnposition - $pages_prev;
				$staticpos = $prev_ppos - 1;
				$prev_ppos = $prev_ppos - 2;
				$pvst = $prev_ppos * $nr_searchres;
				$pvnd = ($prev_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = "<a href=\"$admin_url/recip2.cgi?st=$pvst&nd=$pvnd&total=$rows\"><<</a> " . $pgstring;
				}

			####  PAGES NAVIGATION
			if (($cnposition + $pages_next) < $pages)
				{
				$next_ppos = $cnposition + $pages_next;
				$staticpos = $next_ppos + 1;
				$pvst = $next_ppos * $nr_searchres;
				$pvnd = ($next_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = $pgstring . "<a href=\"$admin_url/recip2.cgi?st=$pvst&nd=$pvnd&total=$rows\">>></a> ";
				}


if ($pgstring eq "0") { $pgstring = ""; }
if ($pgstring eq " [1] ") { $pgstring = ""; }
if ($pgstring ne "") {$pgstring =  "Pages: " . $pgstring; }




### PREV NEXT PAGES

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}


$spls = $modp;
if ($spls == 0){$spls++;}

if ($nd <= ($icnt - $spls))
{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/recip2.cgi?st=$st1&nd=$nd1&total=$rows\">Next Page >></a> ";
}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/recip2.cgi?st=$st1&nd=$nd1&total=$rows\"><< Previous Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}




if ($rows > 1)
	{
	
$function_table = qq[





<form method="POST" action="$admin_url/recip2.cgi">
  <input type="hidden" name="fct" value="email_all"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#E5E5E5" height="147">
    <tr>
      <td width="100%" height="16" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFE135" class="normaltext"><strong>Reciprocal
      Link Report Options: </strong></td>
    </tr>
    <tr>
      <td width="20%" height="27" align="center" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="Send Email to All" name="B1"> </td>
      <td width="70%" height="27" bgcolor="#FFFFFF" class="normaltext">Use this option to send email to link owners
      where your reciprocal link could not be found. </td>
    </tr>
    <tr>
      <td width="20%" height="27" align="center" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="Clear Report" name="B2"> </td>
      <td width="80%" height="27" bgcolor="#FFFFFF" class="normaltext">Clear this report indicating reciprocal
      links where your link was not found. </td>
    </tr>
    <tr>
      <td width="20%" height="27" align="center" bgcolor="#FFFFFF" class="normaltext"><select name="perpage"
      size="1">
        <option value="10"> 10 </option>
        <option value="20"> 20 </option>
        <option value="50"> 50 </option>
        <option value="100"> 100 </option>
        <option value="200"> 200 </option>
        <option value="500"> 500 </option>
        <option value="1000"> 1000 </option>
      </select> <input type="submit" value="  Go  " name="B3"> </td>
      <td width="80%" height="27" bgcolor="#FFFFFF" class="normaltext">Choose a number of entries to list on a 'per
      page' basis. </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>



<form method="POST" action="$admin_url/recip2.cgi" name="select_all">
<input type="hidden" name="itemnrs" value="$cbcnt">  
  <input type="hidden" name="fct" value="do_options">
  
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#E5E5E5">
  <tr>
    <td width="100%" height="30" colspan="4" background="$web_url/bar6.gif">
    <span class="normaltext"><strong>Reciprocal Link Report: (Listing Links Where No Reciprocal
    Links Could Be Found)</strong></span></td>
  </tr>
 
  <tr>
     <td width="1%" bgcolor="#F9F9F9" align="center"></td>
     <td width="50%" bgcolor="#F9F9F9" height="30"><span class="normaltext"><strong>Link
     Details:</strong></span></td>
     <td width="49%" bgcolor="#F9F9F9" colspan="2"><span class="normaltext"><strong>Check
     Dates / Page Fetch Result</strong></span></td>
  </tr>
 
  
  $rlinks

	
      <tr>
        <td width="1%" bgcolor="#F9F9F9" align="center" height="34"><img src="$web_url/dar3.gif"></td>
        <td width="99%" bgcolor="#F9F9F9" height="34" colspan="3"><span class="normaltext"><select
        name="opaction" size="1">
          <option value="remove">Remove Report Entry (Won't Delete Link)</option>
          <option value="sendmail">Send Email To Selected</option>
          <option value="edit">Edit Link(s)</option>
          <option value="delete">Delete Link(s) From Database</option>
          <option value="move">Move Link(s)</option>
        </select><input type="submit" value="   Go   " name="B2"
        onClick="submitForm(document.select_all,0); return false;"></span></td>
      </tr>
      <tr>
        <td width="100%" bgcolor="#FFFFFF" colspan="4" height="30"><span class="normaltext"><a
        href="javascript:checkall('select_all',true)">Check All</a> | <a
        href="javascript:checkall('select_all',false)">UnCheck All</a> </span></td>
      </tr>
      <tr>
        <td width="100%" bgcolor="#FFFFFF" colspan="4" height="30"><span class="normaltext"><strong>$prevnext</strong>
        </span></td>
      </tr>
      
         <tr>
		        <td width="100%" bgcolor="#FFFFFF" colspan="4" height="30"><span class="normaltext">
		        $pgstring</span></td>
      </tr>

	</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
	
	</form>
      
      ];
	
	}
	else
	{
	$function_table = qq[

<div align="center"><center>

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#E5E5E5">
  <tr>
    <td width="100%" bgcolor="#FFFFFF" align="center" height="100"><strong>
    <span class="normaltext">There are currently no reciprocal links where your link could not be
    found. </span></strong><p><span class="normaltext"><a
    href="$admin_url/p_recip.cgi?fct=check">Click Here</a> to check if your reciprocal link
    exists on links you have in your database.</span></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

</center></div>


    ];
	
	
	}


$hbox = acs::get_heading_box("$web_url/ic_settings6.gif", "Reciprocal Link Checker", qq[
If you require users to link back to your site (place a reciprocal link) when submitting a URL then this Plug-In will check if they are still linking to you. If they are not linking to you anymore then you may send them email asking them to place the link back. This Plug-In also comes with options where you can remove or manage links where the link owner has removed your reciprocal link.
<BR><b>Found $rows listings that did not have a reciprocal linkback.</b>
]); 


print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
 
<script LANGUAGE="JavaScript">
<!-- Hide 

function checkall(formname,thestate)
	{
	BoxNames=new Array($sel_options)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}


function submitForm(theForm, selv) 
  {
  BoxNames=new Array($sel_options)
  windowName = "PowerSeek";
  windowURL = theForm.action + '?';
  var c = 0;
	for (c=0;c < BoxNames.length; c++)
		{
		chvl = eval("theForm." + BoxNames[c] + ".checked");
		if (chvl)
			{
			boxnm = eval("theForm." + BoxNames[c] + ".value");
			windowURL = windowURL + BoxNames[c] + '=' + boxnm + '&';
			}
		}
    windowURL = windowURL + 'nr_links=' + '$cbcnt' + '&';
    windowURL = windowURL + 'fct=do_options&';
    
    if (selv == 1)
    	{
    	windowURL = windowURL + 'opaction1=' + theForm.opaction1.value;
    	}
    	else
    	{
    	windowURL = windowURL + 'opaction=' + theForm.opaction.value;
    	}
    
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=750,height=550'";
    var popupwin = null;
    
    var random = parseInt(Math.random()*10000)
    
    myWindow = window.open(windowURL, 'popupwin' + random, myspecs);
    myWindow.focus();
  } 




// End Hide -->
</script> 
</head>

<body>

$hbox



<form method="POST" action="$admin_url/p_recip.cgi">
  <input type="hidden" name="fct" value="check"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#E5E5E5">
    <tr>
      <td width="100%" height="16" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFE135" class="normaltext"><strong>Check
      Reciprocal Links: </strong></td>
    </tr>
    <tr>
      <td width="20%" align="center" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="Check Reciprocal Links" name="B1"> </td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext">Check if your link still exist on other web sites where
      link owners linked to you. </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
$function_table

<BR>

</body>
</html>

];


}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

